package org.vtokarev.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vtokarev.domain.Room;
import org.vtokarev.dto.BookingDto;
import org.vtokarev.service.BookingService;
import org.vtokarev.service.RoomService;
import org.vtokarev.tuples.Pair;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.lang.invoke.MethodHandles;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * The {@code BookingServlet} class processes GET {@code booking} requests generated by users with GUEST and MANAGER role.
 * It collects the necessary data from the request for booking creation, set them as parameters, and forwards them to {@code booking.jsp} view for further processing.
 *
 * @author Vyacheslav Tokarev
 */


@WebServlet(urlPatterns = "/booking", name = "bookingServlet")
public class BookingServlet extends HttpServlet {

    private final static Logger LOGGER = LogManager.getLogger(MethodHandles.lookup().lookupClass());
    BookingService bookingService;
    RoomService roomService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        bookingService = (BookingService) config.getServletContext().getAttribute("app/BookingService");
        roomService = (RoomService) config.getServletContext().getAttribute("app/RoomService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        long id = 0;

        try {
            id = Long.parseLong(req.getParameter("id"));
        } catch (NumberFormatException e) {
            LOGGER.warn("Failed parse id, doGet", e);
            resp.sendRedirect("bookingList");
        }

        if (id == 0) {
            LOGGER.warn("Invalid bookingId");
            resp.sendRedirect("bookingList");
        }
        BookingDto bookingDto = bookingService.getBookingDtoById(id);
        Optional<Room> room = roomService.getRoomById(bookingDto.getBooking().getRoomId());

        room.ifPresent(r -> {
            List<String> images = roomService.getImagePaths(r).stream().map(Pair::getA).collect(Collectors.toList());
            req.setAttribute("images", images);
        });

        req.setAttribute("booking", bookingDto);
        req.getRequestDispatcher("/WEB-INF/jsp/booking.jsp").forward(req, resp);
    }
}
